﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Persistence;
using Infragistics.Persistence.Primitives;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<PhoneNumber> numbers = new List<PhoneNumber>();
            numbers.Add(new PhoneNumber() { Number = 111111 });
            numbers.Add(new PhoneNumber() { Number = 112341 });
            numbers.Add(new PhoneNumber() { Number = 555555 });

            List<Contact> data = new List<Contact>();
            data.Add(new Contact() { Id = 1, Name = "contact1", Phones = numbers });
            data.Add(new Contact() { Id = 2, Name = "contact2", Phones = numbers });
            data.Add(new Contact() { Id = 3, Name = "contact3", Phones = numbers });

            this.DataContext = data;

            this.Closing += new System.ComponentModel.CancelEventHandler(SchedulingQ_Closing);
            
        }

        void SchedulingQ_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            SeralizeGridSettings(dgQResult);
        }

        public static PersistenceSettings GetStandardGridPersistenceSettings()
        {
            PersistenceSettings settings = new PersistenceSettings();
            settings.SavePersistenceOptions = PersistenceOption.OnlySpecified;

            // Filter menu
            PropertyNamePersistenceInfo prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "RowFiltersCollection";
            settings.PropertySettings.Add(prop);

            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "Columns[].Key";
            settings.PropertySettings.Add(prop);

            // Filter menu
            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "Columns[].FilterColumnSettings";
            settings.PropertySettings.Add(prop);

            // Maybe this is for top filter row?
            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "FilteringSettings";
            settings.PropertySettings.Add(prop);

            // Column sort

            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "SortingSettings";
            settings.PropertySettings.Add(prop);

         
            // Column order?
            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "ColumnMovingSettings";
            settings.PropertySettings.Add(prop);

            // Column width?
            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "ColumnResizingSettings";
            settings.PropertySettings.Add(prop);

            // Visible columns?
            prop = new PropertyNamePersistenceInfo();
            prop.PropertyName = "ColumnChooserSettings";
            settings.PropertySettings.Add(prop);

            return settings;

        }

        public static void SeralizeGridSettings(XamGrid grid)
        {
            using (MemoryStream mStream = PersistenceManager.Save(grid, GetStandardGridPersistenceSettings()))
            {
                mStream.Position = 0;
                using (FileStream fs = new FileStream(@"C:\temp\persistence_scheduling.xml", FileMode.Create))
                {
                    mStream.WriteTo(fs);
                }
            }
        }

        public static void DeSeralizeGridSettings(XamGrid grid)
        {
            if (!System.IO.File.Exists(@"C:\temp\persistence_scheduling.xml"))
                return;

            using (FileStream fs = File.OpenRead(@"C:\temp\persistence_scheduling.xml"))
            {
                PersistenceManager.Load(grid, fs, GetStandardGridPersistenceSettings());
            }

        }        

        private void dgQResult_Loaded(object sender, RoutedEventArgs e)
        {
            DeSeralizeGridSettings(dgQResult);            
        }    
				
    }  
 
    public class PhoneNumber
    {
        public int Number { get; set; }
    }

    public class Contact
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public List<PhoneNumber> Phones { get; set; }
    }   
				
}

